Index: branches/2011/DEV_r2739_STFC_dCSE/.gitignore
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/.gitignore	(revision 3837)
+++ branches/2011/DEV_r2739_STFC_dCSE/.gitignore	(revision 3849)
@@ -6,2 +6,4 @@
 *.err
 *.out
+*.o
+*.exe
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/ARCH/arch-gfortran_linux.fcm
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/ARCH/arch-gfortran_linux.fcm	(revision 3837)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/ARCH/arch-gfortran_linux.fcm	(revision 3849)
@@ -15,8 +15,9 @@
 
 
-%NCDF_INC            -I/usr/local/netcdf/include
-%NCDF_LIB            -L/usr/local/netcdf/lib -lnetcdf
+%NCDF_INC            -I/home/kbc59144/MyInstalls/include
+%NCDF_LIB            -L/home/kbc59144/MyInstalls/lib -lnetcdf -lnetcdff
 %FC	             gfortran
-%FCFLAGS             -fdefault-real-8 -O3 -funroll-all-loops -fcray-pointer 
+#%FCFLAGS             -fdefault-real-8 -O3 -funroll-all-loops -fcray-pointer 
+%FCFLAGS             -O0 -g -Wall -Warray-bounds -fbacktrace -fbounds-check -fcheck=all
 %FFLAGS              %FCFLAGS
 %LD                  gfortran
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/ARCH/arch-gfortran_mpi_linux.fcm
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/ARCH/arch-gfortran_mpi_linux.fcm	(revision 3849)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/ARCH/arch-gfortran_mpi_linux.fcm	(revision 3849)
@@ -0,0 +1,30 @@
+# generic gfortran compiler options for linux
+# NCDF_INC    netcdf include file
+# NCDF_LIB    netcdf library
+# FC          Fortran compiler command
+# FCFLAGS     Fortran compiler flags
+# FFLAGS      Fortran 77 compiler flags
+# LD          linker
+# LDFLAGS     linker flags, e.g. -L<lib dir> if you have libraries in a
+# FPPFLAGS    pre-processing flags
+# AR          assembler
+# ARFLAGS     assembler flags
+# MK          make
+# USER_INC    additional include files for the compiler,  e.g. -I<include dir>
+# USER_LIB    additional libraries to pass to the linker, e.g. -l<library>
+
+
+%NCDF_INC            -I/home/kbc59144/MyInstalls/include
+%NCDF_LIB            -L/home/kbc59144/MyInstalls/lib -lnetcdf -lnetcdff
+%FC	             mpif90
+%FCFLAGS             -fdefault-real-8 -O3 -funroll-all-loops -fcray-pointer 
+%FFLAGS              %FCFLAGS
+%LD                  mpif90
+%LDFLAGS
+%FPPFLAGS            -P -C -traditional
+%AR                  ar
+%ARFLAGS             -rs
+%MK                  gmake
+%USER_INC            %NCDF_INC
+%USER_LIB            %NCDF_LIB
+
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/CONFIG/ORCA2_LIM/cpp_ORCA2_LIM.fcm
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/CONFIG/ORCA2_LIM/cpp_ORCA2_LIM.fcm	(revision 3837)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/CONFIG/ORCA2_LIM/cpp_ORCA2_LIM.fcm	(revision 3849)
@@ -1,1 +1,1 @@
- bld::tool::fppkeys key_trabbl key_vectopt_loop key_orca_r2 key_lim2 key_dynspg_flt key_diaeiv key_ldfslp key_traldf_c2d key_traldf_eiv key_dynldf_c3d key_dtatem key_dtasal key_tradmp key_zdftke key_zdfddm key_zdftmx key_iomput 
+ bld::tool::fppkeys key_trabbl  key_orca_r2 key_lim2 key_dynspg_flt key_diaeiv key_ldfslp key_traldf_c2d key_traldf_eiv key_dynldf_c3d key_dtatem key_dtasal key_tradmp key_zdftke key_zdfddm key_zdftmx   key_mpp_mpi     key_mpp_rkpart
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 3837)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 3849)
@@ -157,5 +157,6 @@
    INTEGER, SAVE, PUBLIC                 :: nn_cpnode = 4 ! Number of cores per 
                                                           ! compute node on current computer
- 
+   LOGICAL, SAVE, PUBLIC                 :: nn_readpart = .FALSE. ! Whether to read partition from
+                                                            ! file (1) or not (0)
    REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE :: tampon  ! buffer in case of bsend
 
@@ -263,5 +264,6 @@
       !
       NAMELIST/nammpp/ cn_mpi_send, nn_buffer, jpni, jpnj, jpnij, &
-                       nn_xfactors, nn_yfactors, nn_pttrim, nn_cpnode
+                       nn_readpart, nn_xfactors, nn_yfactors,     &
+                       nn_pttrim, nn_cpnode
       !!----------------------------------------------------------------------
       !
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/mapcomm_mod.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/mapcomm_mod.F90	(revision 3837)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/mapcomm_mod.F90	(revision 3849)
@@ -156,5 +156,5 @@
 
   ! Public routines
-  PUBLIC :: mapcomms, iprocmap
+  PUBLIC :: mapcomms, iprocmap, set_num_subdomains
 
   ! Public variables
@@ -165,10 +165,9 @@
   PUBLIC :: nsendp,nsendp2d,nrecvp,nrecvp2d,npatchsend,npatchrecv, &
             nxsendp,nysendp,nzsendp,nxrecvp,nyrecvp,nzrecvp,       &
-            idesrecvp,jdesrecvp,isrcsendp,jsrcsendp
+            idesrecvp,jdesrecvp,isrcsendp,jsrcsendp, nprocp
 
   PUBLIC :: ielb,  ieub,  pielb, pjelb, pieub, pjeub,                    &
             iesub, jesub, jeub, ilbext, iubext, jubext, jlbext, pnactive,&
-            piesub, pjesub, jelb, pilbext, pjlbext, pjubext, piubext,    &
-            nprocp
+            piesub, pjesub, jelb, pilbext, pjlbext, pjubext, piubext
 
   PUBLIC :: NONE         &
@@ -191,8 +190,20 @@
 
   ! Switch for trimming points below ocean floor from halo swaps
-  !LOGICAL, PARAMETER :: msgtrim_z = .TRUE. ! .FALSE.
-  LOGICAL, PUBLIC, SAVE      :: msgtrim_z
+  ! Defaults to true unless set via NEMO_MSGTRIM_Z environment var.
+  LOGICAL, PUBLIC, SAVE :: msgtrim_z
 
 CONTAINS
+
+  SUBROUTINE set_num_subdomains(npes)
+    IMPLICIT none
+    !!------------------------------------------------------------------
+    !! Set the number of subdomains to partition the domain into.
+    !!------------------------------------------------------------------
+    INTEGER, INTENT(in) :: npes
+
+    nprocp = npes
+
+  END SUBROUTINE set_num_subdomains
+
 
   SUBROUTINE mapcomms ( depth, ibotlvl, nx, ny, jperio, ierr )
@@ -213,6 +224,6 @@
 
     ! Local variables.
-    INTEGER :: i, i1, i2, icol, ihalo, iproc, iprocc, iprocx, &
-               iprocy, j, j1, j2, lumapout, nadd, naddmaxr, naddmaxs
+    INTEGER :: i, i1, i2, ihalo, iproc, iprocc, iprocx, &
+               iprocy, j, j1, j2, nadd, naddmaxr, naddmaxs
     INTEGER :: ldiff0, ldiff1 ! Local vars for coping with wrapping of coords
     INTEGER :: imax, imin ! Max/min value of i that a halo strip can run 
@@ -1302,5 +1313,5 @@
         IF ( addcorner ) THEN
 #if defined ARPDEBUG
-          WRITE (*,FMT="(I3,': ARPDBG adding corner send to ',I2,', dir = ',I1)") &
+          WRITE (*,FMT="(I3,': ARPDBG adding corner send to ',I4,', dir = ',I1)") &
                  narea-1, procid(iprocc),i
 #endif
@@ -1314,5 +1325,5 @@
 
 #if defined ARPDEBUG
-          WRITE (*,FMT="(I3,': ARPDBG adding corner recv. from ',I3,', old dir = ',I1,' new dir = ',I1)") &
+          WRITE (*,FMT="(I3,': ARPDBG adding corner recv. from ',I4,', old dir = ',I1,' new dir = ',I1)") &
                  narea-1, procid(iprocc),i, j
 #endif
@@ -1380,5 +1391,5 @@
 ! ARP - for debugging only
 !!$        IF(iprocmap == 0)THEN
-!!$           WRITE(*,"('iprocmap: failed to find owner PE for (',I3,I3,')')") ia, ja
+!!$           WRITE(*,"('iprocmap: failed to find owner PE for (',I3,1x,I3,')')") ia, ja
 !!$           WRITE(*,*) 'PE domains are [xmin:xmax][ymin:ymax]:'
 !!$           DO iproc=1,nprocp,1
@@ -1826,5 +1837,5 @@
 
         ! Can any points along the left (low i) edge be trimmed?
-        left_edge: DO i=ilo, ihi - nextra
+        left_edge: DO i=ilo, ihi
           DO j=jlo, jhi
              ! depth is global mask, i and j are local coords
@@ -1856,5 +1867,5 @@
 
         ! Can any points along the right (high i) edge be trimmed?
-        right_edge: DO i=ihi, ilo + nextra, -1
+        right_edge: DO i=ihi, ilo, -1
           DO j=jlo, jhi
 !            IF (depth(i+nimpp-1-nextra,j+njmpp-1) .ne. land) exit right_edge
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/partition_mod.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/partition_mod.F90	(revision 3837)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/partition_mod.F90	(revision 3849)
@@ -1,4 +1,4 @@
 MODULE partition_mod
-   USE par_oce, ONLY: jpni, jpnj, jpi, jpj, jpim1, jpjm1, jpij, &
+   USE par_oce, ONLY: jpni, jpnj, jpnij, jpi, jpj, jpim1, jpjm1, jpij, &
                       jpreci, jprecj, jpk, jpkm1, jperio, jpiglo, jpjglo
    USE dom_oce, ONLY: ln_zco, nbondi, nbondj, nidom, npolj, &
@@ -18,5 +18,5 @@
    USE lib_mpp,        ONLY: mppsize, mppsync, mpi_comm_opa,                &
                              MAX_FACTORS, xfactors, yfactors, nn_pttrim,    &
-                             nn_cpnode
+                             nn_cpnode, nn_readpart
 #endif
    USE lib_mpp,        ONLY: ctl_stop, ctl_warn
@@ -34,5 +34,7 @@
                                                  ! (1 for ocean, 0 for land)
                                                  ! set in nemogcm.F90
-   INTEGER, SAVE, ALLOCATABLE, DIMENSION(:,:), TARGET :: ibotlevel ! Holds the bottom level of the ocean at each grid point - used for trimming halos in z direction
+   ! Holds the bottom level of the ocean at each grid point - used for 
+   ! trimming halos in z direction
+   INTEGER, SAVE, ALLOCATABLE, DIMENSION(:,:), TARGET :: ibotlevel 
 
    ! Parameters for the cost function used when evaluating different 
@@ -75,4 +77,5 @@
    PUBLIC imask, ibotlevel, smooth_global_bathy, global_bot_level, partition_mask_alloc
    PUBLIC mpp_init3, partition_rk, partition_mca_rk, write_partition_map
+   PUBLIC read_partition, write_partition
 
 CONTAINS
@@ -292,4 +295,8 @@
       CALL mpp_init_ioipsl()
 
+      ! Write this partition to file in the format that the code can
+      ! read
+      CALL write_partition()
+
       ! ARPDBG - test comms setup
       CALL mpp_test_comms(imask, ibotlevel)
@@ -396,8 +403,4 @@
 #if defined key_mpp_mpi
 
-      ! IMPORTANT: Set the number of PEs to partition over (mapcomm_mod 
-      ! module variable)
-      nprocp = mppsize
-
 #if defined PARTIT_DEBUG
       IF(lwp)WRITE(*,*) 'ARPDBG partition_rk: jpn{i,j} = ',jpni,jpnj
@@ -478,8 +481,4 @@
        ! set that here
        myinst = narea - 1
-
-       ! IMPORTANT: set the number of PEs to partition over (mapcomm_mod 
-       ! module variable)
-       nprocp = mppsize
 
        ! Factorise the total number of MPI processes that we have
@@ -682,4 +681,5 @@
       jpni = nprocx
       jpnj = nprocy
+      jpnij = jpni*jpnj
 
       IF (lwp) THEN
@@ -1388,32 +1388,42 @@
 
 
-   SUBROUTINE finish_partition()
-      USE mapcomm_mod, ONLY: ielb,ieub,pielb,pjelb,pieub,pjeub, &
-                             iesub,jesub,jeub,ilbext,iubext,jubext, &
+   SUBROUTINE finish_partition(fromFile)
+      USE mapcomm_mod, ONLY: ielb,ieub,pielb,pjelb,pieub,pjeub,          &
+                             iesub,jesub,jeub,ilbext,iubext,jubext,      &
                              jlbext,pnactive,piesub,pjesub,jelb,pilbext, &
-                             piubext, pjlbext, pjubext, &
+                             piubext, pjlbext, pjubext,                  &
                              trimmed, nidx,eidx,sidx,widx
       IMPLICIT NONE
+      LOGICAL, INTENT(in), OPTIONAL :: fromFile
+      ! Locals
       INTEGER :: iproc, ierr
-
-      ! Set the external boundary flags before boundaries are
-      ! altered by the trimming process and it becomes more difficult
-      ! to recognize which were the external boundaries.
+      LOGICAL :: lFromFile
+
+      ! Check to see whether we're dealing with a partion that has been
+      ! read from file. If we are then there are some things we don't
+      ! calculate here.
+      lFromFile = .FALSE.
+      IF( PRESENT(fromFile) ) lFromFile = fromFile
+
+      IF(.NOT. lFromFile)THEN
+         ! Set the external boundary flags before boundaries are
+         ! altered by the trimming process and it becomes more difficult
+         ! to recognize which were the external boundaries.
       
-      DO iproc=1, nprocp, 1
-           pilbext(iproc) = pielb(iproc).EQ.1
-           piubext(iproc) = pieub(iproc).EQ.jpiglo
-           pjlbext(iproc) = pjelb(iproc).EQ.1
-           pjubext(iproc) = pjeub(iproc).EQ.jpjglo
-        ENDDO
-
-      ! Trim off redundant rows and columns containing all land.
-        IF(.NOT. ALLOCATED(trimmed) )THEN
-           ALLOCATE(trimmed(4,nprocp), Stat=ierr)
-           IF(ierr /= 0)THEN
-              CALL ctl_stop('STOP',    &
-                            'Failed to allocate memory for domain trimming')
-           END IF
-        END IF
+         DO iproc=1, nprocp, 1
+            pilbext(iproc) = pielb(iproc).EQ.1
+            piubext(iproc) = pieub(iproc).EQ.jpiglo
+            pjlbext(iproc) = pjelb(iproc).EQ.1
+            pjubext(iproc) = pjeub(iproc).EQ.jpjglo
+         ENDDO
+
+         ! Trim off redundant rows and columns containing all land.
+         IF(.NOT. ALLOCATED(trimmed) )THEN
+            ALLOCATE(trimmed(4,nprocp), Stat=ierr)
+            IF(ierr /= 0)THEN
+               CALL ctl_stop('STOP',    &
+                             'Failed to allocate memory for domain trimming')
+            END IF
+         END IF
 
 #if defined key_mpp_mpi
@@ -1430,49 +1440,50 @@
         ENDIF
 #else
-        trimmed(1:4,1:nprocp) = .FALSE.
-#endif
-
-        ! Lower boundary (long.) of sub-domain, GLOBAL coords
-        ! before correction for global halos
-        nimpp = pielb(narea)
-
-        ! Is the domain on an external LONGITUDE boundary?
-        nbondi = 0
-        ilbext = pilbext(narea)
-        IF(ilbext)THEN
-           nbondi = -1
-        END IF
-
-        IF( (.NOT. ilbext) .OR. (ilbext .AND. trimmed(widx,narea)) )THEN
-           ! It isn't, which means we must shift its lower boundary by
-           ! -jpreci to allow for the overlap of this domain with its
-           ! westerly neighbour.
-           nimpp = nimpp - jpreci
-        END IF
-
-        iubext = piubext(narea)
-        IF(iubext)THEN
-           nbondi = 1
-           IF(ilbext)nbondi = 2 ! Both East and West boundaries are at 
-                                ! edges of global domain
-        END IF
-
-        ! Set local values for limits in global coords of the sub-domain 
-        ! owned by this process.
-        ielb   = pielb (narea)
-        ieub   = pieub (narea)
-        iesub  = piesub(narea)
-
-        jpi  = iesub + 2*jpreci ! jpi is the same for all domains - this is
-                                ! what original decomposition did
-        nlci = jpi
-
-        ! If the domain is at the edge of the model domain and a cyclic 
-        ! East-West b.c. is in effect then it already incorporates one 
-        ! extra halo column (because of the way the model domain itself is
-        ! set-up). If we've trimmed-off dry rows and columns then, even if
-        ! a domain is on the model boundary, it may still need a halo so
-        ! we add one.
-        IF( nbondi == -1 .AND. (.NOT. trimmed(widx,narea))  )THEN
+         trimmed(1:4,1:nprocp) = .FALSE.
+#endif
+      END IF ! not read from file
+
+      ! Lower boundary (long.) of sub-domain, GLOBAL coords
+      ! before correction for global halos
+      nimpp = pielb(narea)
+
+      ! Is the domain on an external LONGITUDE boundary?
+      nbondi = 0
+      ilbext = pilbext(narea)
+      IF(ilbext)THEN
+         nbondi = -1
+      END IF
+
+      IF( (.NOT. ilbext) .OR. (ilbext .AND. trimmed(widx,narea)) )THEN
+         ! It isn't, which means we must shift its lower boundary by
+         ! -jpreci to allow for the overlap of this domain with its
+         ! westerly neighbour.
+         nimpp = nimpp - jpreci
+      END IF
+
+      iubext = piubext(narea)
+      IF(iubext)THEN
+         nbondi = 1
+         IF(ilbext)nbondi = 2 ! Both East and West boundaries are at 
+                              ! edges of global domain
+      END IF
+
+      ! Set local values for limits in global coords of the sub-domain 
+      ! owned by this process.
+      ielb   = pielb (narea)
+      ieub   = pieub (narea)
+      iesub  = piesub(narea)
+
+      jpi  = iesub + 2*jpreci ! jpi is the same for all domains - this is
+                              ! what original decomposition did
+      nlci = jpi
+
+      ! If the domain is at the edge of the model domain and a cyclic 
+      ! East-West b.c. is in effect then it already incorporates one 
+      ! extra halo column (because of the way the model domain itself is
+      ! set-up). If we've trimmed-off dry rows and columns then, even if
+      ! a domain is on the model boundary, it may still need a halo so
+      ! we add one.
+      IF( nbondi == -1 .AND. (.NOT. trimmed(widx,narea))  )THEN
            ! Western boundary
            ! First column of global domain is actually a halo but NEMO
@@ -1547,8 +1558,8 @@
         nlcj = jpj
 
-! Unlike the East-West boundaries, the global domain does not include
-! halo (rows) at the Northern and Southern edges. In fact, there is no
-! cyclic boundary condition in the North-South direction so there are no
-! halos at all at the edges of the global domain.
+      ! Unlike the East-West boundaries, the global domain does not include
+      ! halo (rows) at the Northern and Southern edges. In fact, there is no
+      ! cyclic boundary condition in the North-South direction so there are no
+      ! halos at all at the edges of the global domain.
       IF( nbondj == -1 .AND. (.NOT. trimmed(sidx,narea)) )THEN
          ! Southern edge
@@ -2772,3 +2783,139 @@
     END SUBROUTINE global_bot_level
 
+
+    SUBROUTINE read_partition(ierr)
+      USE par_oce, ONLY: jpni, jpnj, jpnij
+      USE mapcomm_mod, ONLY: eidx, widx, sidx, nidx, trimmed, &
+                             pilbext, piubext, pjlbext, pjubext
+      IMPLICIT none
+      INTEGER, INTENT(out) :: ierr
+      ! Locals
+      INTEGER, PARAMETER :: funit = 1099
+      INTEGER :: idom, ndom
+      CHARACTER(len=200) :: linein
+      !======================================================================
+
+      ierr = 0
+
+      OPEN(UNIT=funit, file='partition.dat', status='OLD', &
+           ACTION='READ', IOSTAT=ierr)
+      IF(ierr /= 0)THEN
+         CALL ctl_warn('read_partition: failed to read partitioning from file - will calculate it instead.')
+         RETURN
+      END IF
+
+      ! Number of procs in x and y
+      CALL read_next_line(funit, linein, ierr)
+      READ(linein,FMT=*) jpni, jpnj
+
+      ! Store their product
+      jpnij = jpni*jpnj
+
+      ! Check that the implied number of PEs matches that
+      ! in our MPI world
+      ndom = jpni*jpnj
+      IF(ndom /= mppsize)THEN
+         CALL ctl_stop('STOP', &
+                       'read_partition: no. of PEs specified in partition.dat does not match no. of PEs in use by this job.')
+      END IF
+
+      ! Read the description of each sub-domain
+      domains: DO idom = 1, ndom, 1
+
+         ! Coordinates of bottom-left (SW) corner of domain
+         CALL read_next_line(funit, linein, ierr)
+         READ(linein,FMT=*) pielb(idom), pjelb(idom)
+         ! Top-right (NE) corner
+         CALL read_next_line(funit, linein, ierr)
+         READ(linein,FMT=*) pieub(idom), pjeub(idom)
+         ! Whether this domain has external boundaries and has been trimmed
+         CALL read_next_line(funit, linein, ierr)
+         READ(linein,FMT=*) pilbext(idom), trimmed(widx,idom)
+         CALL read_next_line(funit, linein, ierr)
+         READ(linein,FMT=*) piubext(idom), trimmed(eidx,idom)
+         CALL read_next_line(funit, linein, ierr)
+         READ(linein,FMT=*) pjlbext(idom), trimmed(sidx,idom)
+         CALL read_next_line(funit, linein, ierr)
+         READ(linein,FMT=*) pjubext(idom), trimmed(nidx,idom)
+
+         piesub(idom) = pieub(idom) - pielb(idom) + 1
+         pjesub(idom) = pjeub(idom) - pjelb(idom) + 1
+
+      END DO domains
+
+      ! All done - close the file
+      CLOSE(UNIT=funit)
+
+      CALL finish_partition(fromFile=.TRUE.)
+
+    END SUBROUTINE read_partition
+
+    !===================================================================
+
+    SUBROUTINE write_partition
+      USE par_oce, ONLY: jpni, jpnj
+      USE mapcomm_mod, ONLY: eidx, widx, sidx, nidx, trimmed,    &
+                             pjubext, pjlbext, piubext, pilbext, &
+                             pielb, pieub, pjelb, pjeub
+      IMPLICIT none
+      INTEGER, PARAMETER :: funit = 1099
+      INTEGER :: ierr
+      INTEGER :: idom
+
+      ! Only PE 0 (narea==1) writes this file
+      IF(narea /= 1) RETURN
+
+      OPEN(UNIT=funit, file='partition.dat.new', status='REPLACE', &
+           ACTION='WRITE', IOSTAT=ierr)
+      IF(ierr /= 0)THEN
+         CALL ctl_warn('write_partition: failed to write partition description to file.')
+         RETURN
+      END IF
+      WRITE(UNIT=funit,FMT="('#  jpni  jpnj')")
+      WRITE(UNIT=funit,FMT="(I5,1x,I5)") jpni, jpnj
+
+      DO idom = 1, mppsize, 1
+         WRITE(UNIT=funit,FMT="('# Domain: ',I5)") idom
+         IF(idom==1)WRITE(UNIT=funit,FMT="('# Lower bounds: x  y')")
+         WRITE(UNIT=funit,FMT="(I5,1x,I5)") pielb(idom), pjelb(idom)
+         IF(idom==1)WRITE(UNIT=funit,FMT="('# Upper bounds: x  y')")
+         WRITE(UNIT=funit,FMT="(I5,1x,I5)") pieub(idom), pjeub(idom)
+         IF(idom==1)WRITE(UNIT=funit,FMT="('# x: Lower bound external, trimmed')")
+         WRITE(UNIT=funit,FMT="(L5,1x,L5)") pilbext(idom), trimmed(widx,idom)
+         IF(idom==1)WRITE(UNIT=funit,FMT="('# x: Upper bound external, trimmed')")
+         WRITE(UNIT=funit,FMT="(L5,1x,L5)") piubext(idom), trimmed(eidx,idom)
+         IF(idom==1)WRITE(UNIT=funit,FMT="('# y: Lower bound external, trimmed')")
+         WRITE(UNIT=funit,FMT="(L5,1x,L5)") pjlbext(idom), trimmed(sidx,idom)
+         IF(idom==1)WRITE(UNIT=funit,FMT="('# y: Upper bound external, trimmed')")
+         WRITE(UNIT=funit,FMT="(L5,1x,L5)") pjubext(idom), trimmed(nidx,idom)
+      END DO
+
+      CLOSE(UNIT=funit)
+
+    END SUBROUTINE write_partition
+
+    SUBROUTINE read_next_line(funit, linein, ierr)
+      IMPLICIT none
+      !!------------------------------------------------------------------
+      INTEGER,            INTENT( in) :: funit  ! Unit no. to read
+      CHARACTER(len=200), INTENT(out) :: linein ! String containing next
+                                                ! non-comment line in file
+      INTEGER,            INTENT(out) :: ierr   ! Error flag (0==OK)
+      !!------------------------------------------------------------------
+
+      ierr = 0
+
+      READ(UNIT=funit,FMT="(200A)") linein
+
+      ! Comment lines begin with '#'. Skip those plus any blank
+      ! lines...
+      DO WHILE( INDEX( TRIM(ADJUSTL(linein)),'#') /= 0 .OR. &
+                LEN_TRIM(linein) == 0 )
+         READ(UNIT=funit,FMT="(200A)") linein   
+      END DO
+
+      WRITE(*,*)'returning linein >>'//linein//'<<'
+
+    END SUBROUTINE read_next_line
+
 END MODULE partition_mod
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfgls.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfgls.F90	(revision 3837)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfgls.F90	(revision 3849)
@@ -1433,5 +1433,5 @@
       !
       INTEGER ::   jit, jk   ! dummy loop indices
-      INTEGER ::   id1, id2, id3, id4, id5, id6, id7, id8
+      INTEGER ::   id1, id2, id3, id4, id5, id6
       INTEGER ::   ji, jj, ikbu, ikbv
       REAL(wp)::   cbx, cby
@@ -1448,5 +1448,5 @@
             id6 = iom_varid( numror, 'mxln' , ldstop = .FALSE. )
             !
-            IF( MIN( id1, id2, id3, id4, id5, id6, id7, id8 ) > 0 ) THEN        ! all required arrays exist
+            IF( MIN( id1, id2, id3, id4, id5, id6 ) > 0 ) THEN        ! all required arrays exist
                CALL iom_get( numror, jpdom_autoglo, 'en'    , en     )
                CALL iom_get( numror, jpdom_autoglo, 'avt'   , avt    )
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 3837)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 3849)
@@ -601,10 +601,11 @@
       USE iom,            ONLY: jpiglo, jpjglo, wp, jpdom_unknown, &
                                 iom_open, iom_get, iom_close
-      USE mapcomm_mod, ONLY: ielb, ieub, pielb, pjelb, pieub, pjeub, &
-                             iesub, jesub, jeub, ilbext, iubext, jubext, &
+      USE mapcomm_mod, ONLY: ielb, ieub, pielb, pjelb, pieub, pjeub,          &
+                             iesub, jesub, jeub, ilbext, iubext, jubext,      &
                              jlbext, pnactive, piesub, pjesub, jelb, pilbext, &
-                             piubext, pjlbext, pjubext, LAND, msgtrim_z
-      USE partition_mod, ONLY: partition_rk, partition_mca_rk, &
-                               imask, ibotlevel, partition_mask_alloc, &
+                             piubext, pjlbext, pjubext, LAND, trimmed,        &
+                             msgtrim_z, set_num_subdomains
+      USE partition_mod, ONLY: partition_rk, partition_mca_rk, read_partition, &
+                               imask, ibotlevel, partition_mask_alloc,         &
                                smooth_global_bathy, global_bot_level
       USE par_oce,       ONLY: do_exchanges
@@ -645,8 +646,10 @@
       END IF
 
-      ! Check whether user has specified halo trimming in z via environment variable
+      ! Check whether user has specified halo trimming in z via environment 
+      ! variable.
       ! Halo trimming in z is on by default
       msgtrim_z = .TRUE.
-      CALL GET_ENVIRONMENT_VARIABLE(NAME='NEMO_MSGTRIM_Z', VALUE=lstr, STATUS=ierr)
+      CALL GET_ENVIRONMENT_VARIABLE(NAME='NEMO_MSGTRIM_Z', VALUE=lstr, &
+                                    STATUS=ierr)
       IF( ierr == 0)THEN
          READ(lstr,FMT="(I)",IOSTAT=ierr) lztrim
@@ -658,8 +661,5 @@
       END IF
 
-      WRITE(*,*) 'ARPDBG: msgtrim_z = ',msgtrim_z
-
-      ! Factorise the number of MPI PEs to get jpi and jpj as usual
-      CALL nemo_partition(num_pes)
+      IF(lwp) WRITE(*,*) 'ARPDBG: msgtrim_z = ',msgtrim_z
 
       ! ============================
@@ -674,15 +674,13 @@
       CALL dom_nam()
 
-      ! Allocate these arrays so we can use domzgr::zgr_z routine; free them at
+      ! Allocate these arrays so we can use domzgr::zgr_z routine; free them
       ! when we're done so as not to upset the 'official' allocation once
       ! the domain decomposition is done.
       ALLOCATE(gdepw_0(jpk), gdept_0(jpk), e3w_0(jpk), e3t_0(jpk), &
-               ! Need many global, 3D arrays if zgr_zco is to be called
-               !gdepw(jpiglo,jpjglo,jpk), gdept(jpiglo,jpjglo,jpk), &
-               !gdep3w(jpiglo,jpjglo,jpk), e3t(jpiglo,jpjglo,jpk),  &
                mig(jpiglo), mjg(jpjglo), &
                mbathy(jpiglo,jpjglo), bathy(jpiglo,jpjglo), Stat=ierr)
       IF(ierr /= 0)THEN
-         CALL ctl_stop('nemo_recursive_partition: failed to allocate zgr_z() arrays')
+         CALL ctl_stop('STOP', &
+                       'nemo_recursive_partition: failed to allocate zgr_z() arrays')
          RETURN
       END IF
@@ -743,10 +741,10 @@
       ! Allocate partitioning arrays.
 
-      IF ( .not.allocated(pielb) ) THEN
+      IF ( .NOT. ALLOCATED(pielb) ) THEN
          ALLOCATE (pielb(num_pes),   pieub(num_pes), piesub(num_pes),     &
                    pilbext(num_pes), piubext(num_pes),                    &
                    pjelb(num_pes),   pjeub(num_pes), pjesub(num_pes),     &
                    pjlbext(num_pes), pjubext(num_pes), pnactive(num_pes), &
-                   Stat = ierr)
+                   trimmed(4,num_pes), Stat = ierr)
          IF(ierr /= 0)THEN
             CALL ctl_stop('STOP', &
@@ -756,14 +754,32 @@
       ENDIF
 
-      ! Now we can do recursive k-section partitioning
-      ! ARPDBG - BUG if limits on array below are set to anything other than
-      ! 1 and jp{i,j}glo then check for external boundaries in a few lines
-      ! time WILL FAIL!
-      !      CALL partition_rk ( imask, 1, jpiglo, 1, jpjglo, ierr )
-
-      ! Multi-core aware version of recursive k-section partitioning. Currently
-      ! only accounts for whether a grid point is wet or dry. It has no knowledge
-      ! of the number of wet levels at a point.
-      CALL partition_mca_rk ( imask, 1, jpiglo, 1, jpjglo, ierr )
+      ! Set error flag so that we calculate domain decomp if not reading
+      ! existing decomposition or if read fails.
+      ierr = 1
+
+      IF( nn_readpart )THEN
+         ! Read the partitioning to use from disk 
+         CALL read_partition(ierr)
+         IF ( ierr /= 0 ) THEN
+            CALL ctl_warn('Read of pre-calculated domain decomposition failed - will calculate one instead.')
+         END IF
+      END IF
+
+      ! Set the number of sub-domains for which we are to partition 
+      ! (module var in mapcomm_mod)
+      CALL set_num_subdomains(num_pes)
+
+      IF(ierr /= 0)THEN
+         ! Multi-core aware version of recursive k-section partitioning. 
+         ! Currently only accounts for whether a grid point is wet or dry.
+         ! It has no knowledge of the number of wet levels at a point.
+         CALL partition_mca_rk ( imask, 1, jpiglo, 1, jpjglo, ierr )
+
+         ! Now we can do recursive k-section partitioning
+         ! ARPDBG - BUG if limits on array below are set to anything other than
+         ! 1 and jp{i,j}glo then check for external boundaries in a few lines
+         ! time WILL FAIL!
+         ! CALL partition_rk ( imask, 1, jpiglo, 1, jpjglo, ierr )
+     END IF
 
       ! Check the error code from partitioning.
@@ -854,5 +870,5 @@
       ! Search backwards from the square root of n.
 
-      fact_loop: DO kna=SQRT(REAL(kn)),1,-1
+      fact_loop: DO kna=INT(SQRT(REAL(kn))),1,-1
          IF ( kn/kna*kna == kn ) THEN
             EXIT fact_loop
